import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Boss here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Boss  extends Actor
{
    public boolean scriptrun=true;
    public int scriptcount=50;
    public int speed=2;
    public int lifes=250;
    public int shootcount=45;
    public boolean globalcount=false;
    public int globalcounter=0;
    public int firedelay=0;
    public int fireruns=0;
    public int pattern;
    public boolean life=true;
    public boolean patterns=true;
    public int firecount1=0;
    public int firecount2=0;
    public int firecount3=0;
    
    /**
     * Act - do whatever the Boss wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        if(scriptrun)
        {
            script();
            scriptcount--;
        }
        else if(!scriptrun)
        {
            firecount1++;
            firecount2++;
            firecount3++;
            move();
            fire1();
            fire2();
            fire3();
            checkCollision();
            checkLife();
            living();
        }
    }  
    
    public void script()
    {
        if(scriptcount>0)
        {
            setLocation(getX(),getY()+2);   
        }
        else if(scriptcount<=0)
        {
            scriptrun=false;
        }   
    }
    
    public void move()
    {
        if(getX()>=getWorld().getWidth()-150)
            {
                speed=-speed;      
            }
            if(getX()<=150)
            {
                speed=2;      
            }
            setLocation(getX()+speed,getY());   
    }
    
    public void fire1()
    {
        if(firecount1==175)
        {
             getWorld().addObject(new Bullet(1,0), getX()-25, getY()+50);
             getWorld().addObject(new Bullet(1,0), getX()+25, getY()+50);
        }
        if(firecount1==200)
        {
             getWorld().addObject(new Bullet(1,0), getX()-75, getY()+50);
             getWorld().addObject(new Bullet(1,0), getX()+75, getY()+50);
        }
        if(firecount1==225)
        {
             getWorld().addObject(new Bullet(1,0), getX()-125, getY()+20);
             getWorld().addObject(new Bullet(1,0), getX()+125, getY()+20);
             firecount1=0;
        }   
    }
    
    public void fire2()
    {
        if(firecount2==150)
        {
             getWorld().addObject(new Bullet(2,-4), getX(), getY()+50);
             getWorld().addObject(new Bullet(2,-2), getX(), getY()+50);
             getWorld().addObject(new Bullet(2,0), getX(), getY()+50);
             getWorld().addObject(new Bullet(2,0), getX(), getY()+50);
             getWorld().addObject(new Bullet(2,2), getX(), getY()+50);
             getWorld().addObject(new Bullet(2,4), getX(), getY()+50);
             firecount2=0;
        }
    }
    
    public void fire3()
    {
        if(firecount3==60)
        {
            getWorld().addObject(new Bullet(3,0), getX(), getY());
            firecount3=0;
        }
    }
    
    public void hitted()
    {
        lifes=lifes-1;
    }
    
    public void checkCollision()
    {
        Ship ship=(Ship) getOneIntersectingObject(Ship.class);
        if(ship!=null)
        {
            ship.hitted(3);   
        }
    }
    
    public void living()
    {
        if(!life)
        {
            getWorld().removeObject(this);   
        }
    }
      
    public void checkLife()
    {
        if(lifes<=0)
        {
            getWorld().addObject(new Explosion(),getX(),getY());
            getWorld().addObject(new Explosion(),getX()+20,getY()-20);
            getWorld().addObject(new Explosion(),getX()-10,getY()+40);
            getWorld().addObject(new Explosion(),getX()+50,getY()+50);
            getWorld().addObject(new Explosion(),getX()-60,getY()-10);
            ((Space) getWorld()).addScore(500);
            ((Space) getWorld()).livingboss(1);
            life=false;
        }
    }
}
