import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Enemy1 here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Enemy  extends Actor
{
    public int type;
    public int speedtype1=0;
    public int speedtype2=2;
    public int speedtype3=3;
    public int vspeedtype1=4;
    public int vspeedtype2=3;
    public int vspeedtype3=2;
    public int shootcount1=40;
    public int shootcount2=35;
    public int shootcount3=45;
    public int globalcount=0;
    public int movecount=0;
    public int lifes=3;

    public Enemy(int t)
    {
        type=t;
        chooseType();
    }
    /**
     * Act - do whatever the Enemy1 wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        move();
        globalcount++;
        movecount++;
        if(movecount==150)
        movecount=0;
        fire();
        checkCollision();
        bounds();
        life();
    }
    
    public void chooseType()
    {
         if(type==0)
         {
            setImage("Enemy1.png"); 
         }
         if(type==1)
         {
            setImage("Enemy2.png"); 
         }
         if(type==2)
         {
            setImage("Enemy3.png");  
         }
    }
    
    public void move()
    {
        if(type==0)
         {
            setLocation(getX()+speedtype1,getY()+vspeedtype1);
         }
         if(type==1)
         {
            if(movecount<=75)
            {
                setLocation(getX()+speedtype2,getY()+vspeedtype2);
            }
            else if(movecount<=150)
            {
                setLocation(getX()-speedtype2,getY()+vspeedtype2);
            }
            
         }
         if(type==2)
         {
            if(getX()>=getWorld().getWidth()-10)
            {
                speedtype3=-speedtype3;      
            }
            if(getX()<=10)
            {
                speedtype3=2;      
            }
            setLocation(getX()+speedtype3,getY()+vspeedtype3);
         }
    }
    
    public void fire()
    {
        if(type==0&&globalcount==shootcount1)
         {
            getWorld().addObject(new Bullet(1,0), getX()-12, getY());
            getWorld().addObject(new Bullet(1,0), getX()+12, getY());
            globalcount=0;
         }
         if(type==1&&globalcount==shootcount2)
         {
            getWorld().addObject(new Bullet(2,0), getX()+5, getY());
            getWorld().addObject(new Bullet(2,0), getX()-5, getY());
            globalcount=0;
         }
         if(type==2&&globalcount==shootcount3)
         {
            getWorld().addObject(new Bullet(3,0), getX()+0, getY());
            globalcount=0;
         }       
    }
    
    public void hitted()
    {
        lifes=lifes-1;
    }
    
    public void checkCollision()
    {
        Ship ship=(Ship) getOneIntersectingObject(Ship.class);
        if(ship!=null)
        {
            ship.hitted(3);   
        }
    }
    
    public void life()
    {
        if(lifes<=0)
        {
            getWorld().addObject(new Explosion(),getX(),getY());
            dropUpgrade();
            ((Space) getWorld()).addScore(20);
            getWorld().removeObject(this);
        }
    }
    
    public void bounds()
    {
        if(getY()>=getWorld().getHeight()-1 || getX()<=1 || getX()>=getWorld().getWidth()-1)
        {
                getWorld().removeObject(this);
        }  
    }
    
    public void dropUpgrade()
    {
        if(Greenfoot.getRandomNumber(100)<9)
        {
            getWorld().addObject(new Upgrade(), getX(), getY());   
        }
    }
}
