import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Meteorit here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Meteorit  extends Actor
{
    public int speed=Greenfoot.getRandomNumber(5)+2;
    public int vspeed=Greenfoot.getRandomNumber(4)+6;
    public int scalesize;
    public int type;

    public Meteorit(int t)
    {
        type=t;
        scalesize=Greenfoot.getRandomNumber(60)+60;
        GreenfootImage img= getImage();
        img.scale(scalesize,scalesize);
        if(type==0)
        {
            speed=-speed;   
        }
        if(type==1)
        {
            speed=Greenfoot.getRandomNumber(5)+2;   
        }
    }
    /**
     * Act - do whatever the Meteorit wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        move();
        checkCollision();
        bounds();
    }
    
    public void move()
    {
        setLocation(getX()+speed,getY()+vspeed);
    }
    
    public void checkCollision()
    {
        Ship ship=(Ship) getOneIntersectingObject(Ship.class);
        if(ship!=null)
        {
            ship.hitted(3);   
        }
    }
    
    public void bounds()
    {
        if(getY()<=5 || getY()>=getWorld().getHeight()-5 || getX()>=getWorld().getWidth()-5 || getX()<=5)
        {
            getWorld().removeObject(this);   
        }          
    }
}
