import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;

/**
 * Write a description of class SHip here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Ship  extends Actor
{
    public int sidespeed=4;
    public int speed=4;
    public int shoots=1;
    public int grade=1;
    public int lifes=3;
    public Label livescore;
    public int livepoints=3;
    public boolean alreadyFired = false;
    public boolean scriptrun=true;
    public int scriptcount=50;
    public Ship ship;
    public int inviscount=0;
    public int invis=0;
    public int shields=0;
    public int shieldcount=150;
    

    public Ship(Label label)
    {
        livescore=label;
    }
    /**
     * Act - do whatever the SHip wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        if(scriptrun)
        {
            script();
            scriptcount--;
        }
        else if(!scriptrun)
        {
            inviscount--;
            checkInvis();
            checkKeys();
            upgrade();
            life();
        }
    }
    
    public void script()
    {
        if(scriptcount>0)
        {
            setLocation(getX(),getY()-2);   
        }
        else if(scriptcount<=0)
        {
            scriptrun=false;
        }   
    }
    
    public void checkInvis()
    {
        if(inviscount>0)
        {
            invis=1;
            setImage("Ship(dam).png");
        }
        else
        {
            setImage("Ship.png");
            invis=0;
        }
    }
    
    public void checkKeys()
    {
        if(Greenfoot.isKeyDown("left"))
        {
            setLocation(getX()-sidespeed,getY());
        }
        if(Greenfoot.isKeyDown("right"))
        {
            setLocation(getX()+sidespeed,getY());
        }
        if(Greenfoot.isKeyDown("up"))
        {
            setLocation(getX(),getY()-speed);
        }
        if(Greenfoot.isKeyDown("down"))
        {
            setLocation(getX(),getY()+speed);
        }
        if(Greenfoot.isKeyDown("space"))
        {
            if(!alreadyFired)
            {
            fire(grade);
            alreadyFired=true;
            }
        }
        else
        {
            alreadyFired=false;   
        }
        if(Greenfoot.isKeyDown("s"))
        {
            shield();
            shields=1;
        }
        else
        {
            shields=0;   
        }
    }
    
    public void fire(int g)
    {
        if(g==1)
        {
            getWorld().addObject(new Bullet(0,0), getX()-12, getY()-10);
            getWorld().addObject(new Bullet(0,0), getX()+12, getY()-10);
        }
        if(g==2)
        {
            getWorld().addObject(new Bullet(0,0), getX()-12, getY()-10);
            getWorld().addObject(new Bullet(0,0), getX()+12, getY()-10);
            getWorld().addObject(new Bullet(0,0), getX()-8, getY()-10);
            getWorld().addObject(new Bullet(0,0), getX()+8, getY()-10);
        }
        if(g==3)
        {
            getWorld().addObject(new Bullet(0,0), getX()-12, getY()-10);
            getWorld().addObject(new Bullet(0,0), getX()+12, getY()-10);
            getWorld().addObject(new Bullet(0,0), getX()-8, getY()-10);
            getWorld().addObject(new Bullet(0,0), getX()+8, getY()-10);
            getWorld().addObject(new Bullet(0,0), getX(), getY()-10);        
        }
        if(g==4)
        {
            getWorld().addObject(new Bullet(0,0), getX()-12, getY()-10);
            getWorld().addObject(new Bullet(0,0), getX()+12, getY()-10);
            getWorld().addObject(new Bullet(0,-2), getX()-8, getY()-10);
            getWorld().addObject(new Bullet(0,2), getX()+8, getY()-10);
            getWorld().addObject(new Bullet(0,0), getX(), getY()-10);        
        }
        if(g==5)
        {
            getWorld().addObject(new Bullet(0,0), getX()-12, getY()-10);
            getWorld().addObject(new Bullet(0,0), getX()+12, getY()-10);
            getWorld().addObject(new Bullet(0,-2), getX()-8, getY()-10);
            getWorld().addObject(new Bullet(0,2), getX()+8, getY()-10);
            getWorld().addObject(new Bullet(0,-1), getX()-8, getY()-10);
            getWorld().addObject(new Bullet(0,1), getX()+8, getY()-10);
            getWorld().addObject(new Bullet(0,0), getX(), getY()-10);         
        } 
    }
    
    public void shield()
    {
        if(shieldcount>0)
        {
            setImage("Ship(shield).png");
            shieldcount--;
            ((Space) getWorld()).decShield(1);
        }
    }
    
    public void upgrade()
    {
        Actor upg;
        upg=getOneIntersectingObject(Upgrade.class);
        if(upg!=null&&grade<5)
        {
            grade++;
            getWorld().removeObject(upg);
        }
    }
    
    public void hitted(int damage)
    {
        if(invis==0&&shields==0)
        {
            lifes=lifes-damage;
        }    
    }
     
    public void life()
    {
        if(lifes<=0)
        {
            getWorld().addObject(new Explosion(),getX(),getY());
            livepoints--;
            if(livepoints<0)
            {
                ((Space) getWorld()).gameOverScreen();
            }
            else if(livepoints>=0)
            {
                livescore.setText("Lives: "+livepoints);
                setLocation(getWorld().getWidth()/2, 90*getWorld().getHeight()/100);
                lifes=3;
                if(grade!=1)
                {
                    grade--;
                }
                inviscount=100;
                invis=1;
            }
        }
    }
}
