import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.awt.Font;

/**
 * Write a description of class Space here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Space  extends World
{

    public int numberOfStars=50;
    public int globalcounter=0;
    public int headcounter=0;
    public int levelheadcounter=0;
    public boolean levelheader1=true;
    public boolean levelheader2=true;
    public boolean levelheader3=true;
    public boolean levelheaderfinal=true;
    public boolean startbg= true;
    public boolean startup= true;
    public boolean header=true;
    public boolean firstbg=true;
    public int levels=1;
    public boolean level1=false;
    public boolean level2=false;
    public boolean level3=false;
    public boolean levelfinal=false;
    public int levelcounter=0;
    Label head = new Label("Press Space",120);
    Label levelhead1 = new Label("Level: 1",120);
    Label levelhead2 = new Label("Level: 2",120);
    Label levelhead3 = new Label("Level: 3",120);
    Label levelheadfinal = new Label("Boss Stage",120);
    Label over = new Label("Game Over",120);
    Label score = new Label("Score: 0",48);
    Label shield = new Label("Shield: 150",48);
    Label lives = new Label("Lives: 3",48);
    Label level = new Label("Level: 1",48);
    Ship ship = new Ship(lives);
    public int scorecount=0;
    public int shieldcount=150;
    public int spawnEnemyLevel1=11;
    public int spawnMeteoritLevel1=5;
    public int spawnEnemyLevel2=16;
    public int spawnMeteoritLevel2=9;
    public int spawnEnemyLevel3=21;
    public int spawnMeteoritLevel3=13;
    public int leveltime=2000;
    public int deathtimer=0;
    public boolean life=true;

    /**
     * Constructor for objects of class Space.
     * 
     */
    public Space()
    {    
        // Create a new world with 20x20 cells with a cell size of 10x10 pixels.
        super(600, 800, 1);
        setBackground("Front.png");
        setPaintOrder(Meteorit.class,Explosion.class,Label.class,Bullet.class,Ship.class,Enemy.class,Boss.class,Star.class);   
    }
       
    public void act()
    {
        if(startbg)
        {
            start();
            head();
            checkSpace();
        }
        else if(!startbg)
        {
            levels();
        }
    }  
    public void start()
    {
        if(startup)
        {
            setBackground("Front.png");
            addObject(head,getWidth()/2+30,getHeight()/2);
            startup=false;
        }
    }
    
    public void head()
    {
        headcounter++;
        if(headcounter==30)
        {
            removeObject(head);
        }
        if(headcounter==60)
        {
            addObject(head,getWidth()/2+30,getHeight()/2);
            headcounter=0;
        }
    }
    
    public void checkSpace()
    {
        if(Greenfoot.isKeyDown("space"))
        {
            startbg=false;   
        }
    }
    
    public void drawBackground()
    {
        GreenfootImage bg = getBackground();
        bg.setColor(Color.BLACK);
        bg.fill();
        for (int i=0; i<=numberOfStars; i++)
        {
            addObject(new Star(),Greenfoot.getRandomNumber(getWidth()),Greenfoot.getRandomNumber(getHeight()));
            addObject(ship,getWidth()/2, getHeight());
            addObject(shield, getWidth()-60, getHeight()-30);
            addObject(score, getWidth()-60, 30);
            addObject(lives, 60, getHeight()-30);
            addObject(level, 60, 30);  
        }
        firstbg=false;
    }
    
    public void levels()
    {
        if(firstbg)
        {
            removeObject(head);
            drawBackground();
            level1=true;
        }
        if(level1)
        {
            level1();
            levelcounter++;
            level.setText("Level: "+levels);
            if(levelheader1)
            {
                addObject(levelhead1,getWidth()/2+30,getHeight()/2);
                levelheader1=false;
            }
            if(levelcounter==100)
            {
                removeObject(levelhead1);   
            }
        }
        
        if(level2)
        {
            level2();
            levelcounter++;
            level.setText("Level: "+levels);
            if(levelheader2)
            {
                addObject(levelhead2,getWidth()/2+30,getHeight()/2);
                levelheader2=false;
            }
            if(levelcounter==100)
            {
                removeObject(levelhead2);   
            }
        }
        
        if(level3)
        {
            level3();
            levelcounter++;
            level.setText("Level: "+levels);
            if(levelheader3)
            {
                addObject(levelhead3,getWidth()/2+30,getHeight()/2);
                levelheader3=false;
            }
            if(levelcounter==100)
            {
                removeObject(levelhead3);   
            }
        }
        
        if(levelfinal)
        {
            levelfinal();
            levelcounter++;
            level.setText("Level: Final");
            if(levelheaderfinal)
            {
                addObject(levelheadfinal,getWidth()/2+30,getHeight()/2);
                levelheaderfinal=false;
            }
            if(levelcounter==150)
            {
                removeObject(levelheadfinal);   
            }
        }
    }
    
    public void level1()
    {
        createLevel(spawnEnemyLevel1, spawnMeteoritLevel1);
        if(levelcounter==leveltime)
        {
            level1=false;
            level2=true;
            levels++;
            levelcounter=0;
            levels();
        } 
    }
    
    public void level2()
    {
        createLevel(spawnEnemyLevel2, spawnMeteoritLevel2);
        if(levelcounter==leveltime)
        {
            level2=false;
            level3=true;
            levels++;
            levelcounter=0;
            levels();
        } 
    }
    
    public void level3()
    {
        createLevel(spawnEnemyLevel3, spawnMeteoritLevel3);
        if(levelcounter==leveltime)
        {
            level3=false;
            levelfinal=true;
            levels++;
            levelcounter=0;
            levels();
        } 
    }
    
    public void levelfinal()
    {
        if(Greenfoot.getRandomNumber(1000)<400)
        {
            addObject(new Star(),Greenfoot.getRandomNumber(getWidth()),0);
        }
        if(levelcounter==200)
        {
            addObject(new Boss(), getWidth()/2, 0);
        }
        if(!life)
        {
            deathtimer++;
            countDead();
        }
    }
    
    public void createLevel(int e, int m)
    {
        if(Greenfoot.getRandomNumber(1000)<400)
            {
                addObject(new Star(),Greenfoot.getRandomNumber(getWidth()),0);
            }
        if(levelcounter>=100)
        {
            if(Greenfoot.getRandomNumber(1000)<e)
            {
                addObject(new Enemy(Greenfoot.getRandomNumber(3)), Greenfoot.getRandomNumber(getWidth()), 0);
            }
            if(Greenfoot.getRandomNumber(1000)<m)
            {
                addObject(new Meteorit(Greenfoot.getRandomNumber(2)), Greenfoot.getRandomNumber(getWidth()),0);   
            }
        }
    }
        
    public void gameOverScreen()
    {  
        removeObjects(getObjects(null));
        level1=false;
        level2=false;
        level3=false;
        levelfinal=false;
        setBackground("Back Kopie.jpg");
        addObject(new Label("Your Score was: "+scorecount, 48),getWidth()/2+30,95*getHeight()/100);
    }
    
    public void livingboss(int e)
    {
        if(e==1)
        {
            life=false;   
        }
    }
    
    public void countDead()
    {
        if(deathtimer==200)
        {
            gameOverScreen();   
        }
    }
    
    public void addScore(int s)
    {
        scorecount=s+scorecount;
        score.setText("Score: "+scorecount);     
    }
    
    public void decShield(int s)
    {
        shieldcount=shieldcount-s;
        shield.setText("Shield: "+shieldcount);
    }
    
    public void gameOver()
    {   
        
    }
}
