import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;

/**
 * Write a description of class Bullet here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Bullet  extends Actor
{
    public int bulletspeed=6;
    public boolean life=true;
    public int type;
    public int direction;
    GreenfootImage img;

    public Bullet(int t, int d)
    {
        type=t;
        if(type==0)
        {
            img= getImage();
            img.setColor(Color.YELLOW);
            img.scale(2,7);
            img.clear();
            img.fillRect(0,0,2,7);
            bulletspeed=-bulletspeed;   
        }
        if(type==1)
        {
            img= getImage();
            img.setColor(Color.BLUE);
            img.scale(9,9);
            img.clear();
            img.fillOval(0,0,9,9);
            bulletspeed=7;   
        }
        
        if(type==2)
        {
            img= getImage();
            img.setColor(Color.RED);
            img.scale(4,5);
            img.clear();
            img.fillRect(0,0,3,6);
            bulletspeed=8;   
        }
        
        if(type==3)
        {
            img= getImage();
            img.setColor(Color.GREEN);
            img.scale(15,15);
            img.clear();
            img.fillOval(0,0,15,15);
            bulletspeed=5;   
        }
        direction=d;
    }
    /**
     * Act - do whatever the Bullet wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        move();
        checkCollision();
        bounds();
        checkLife();
    }    
            
    public void move()
    {
        setLocation(getX()+direction,getY()+bulletspeed);   
    }
    
    public void checkCollision()
    {
        if(type==0)
        {
            Enemy enemy=(Enemy) getOneIntersectingObject(Enemy.class);
            if(enemy!=null)
            {
                enemy.hitted();
                life=false;
            } 
        }
        if(type==0)
        {
            Meteorit meteorit=(Meteorit) getOneIntersectingObject(Meteorit.class);
            if(meteorit!=null)
            {
                life=false;
            } 
        }
        
        if(type==0)
        {
            Boss boss=(Boss) getOneIntersectingObject(Boss.class);
            if(boss!=null)
            {
                boss.hitted();
                life=false;
            } 
        }
        
        if(type==1)
        {
            Ship ship=(Ship) getOneIntersectingObject(Ship.class);
            if(ship!=null)
            {
                ship.hitted(1);
                life=false;
            }
        }
        if(type==2)
        {
            Ship ship=(Ship) getOneIntersectingObject(Ship.class);
            if(ship!=null)
            {
                ship.hitted(1);
                life=false;
            }
        }
        if(type==3)
        {
            Ship ship=(Ship) getOneIntersectingObject(Ship.class);
            if(ship!=null)
            {
                ship.hitted(2);
                life=false;
            }
        }
    }
    
    public void bounds()
    {
        if(getY()<=10 || getY()>=getWorld().getHeight()-10  || getX()<=10 || getX()>=getWorld().getWidth()-10)
        {
            life=false;  
        }
    }
    
    public void checkLife()
    {
        if(!life)
        {
            getWorld().removeObject(this);   
        }
    }
}
